<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.dashboard.common.IUserPrefsService" %>
<%@ page import="org.wso2.carbon.dashboard.ui.UserPrefsServiceClient" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%
    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    String context = request.getContextPath();

    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext()
                    .getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    // Creating the Service Client for java calls
    /*UserPrefsServiceClient userPrefsServiceClient = new UserPrefsServiceClient(cookie,
                                                                               backendServerURL,
                                                                               configContext,
                                                                               request.getLocale());*/
    IUserPrefsService userPrefsServiceClient =
            (IUserPrefsService) CarbonUIUtil.getServerProxy(new UserPrefsServiceClient(cookie,
                    backendServerURL,
                    configContext,
                    request.getLocale()),
                    IUserPrefsService.class, session);

    // Getting the function name
    String funcName = request.getParameter("func");
    if ("sessionValid".equals(funcName)) {
        out.print(userPrefsServiceClient.isSessionValid());

    } else if ("addGadget".equals(funcName)) {
        String userId = request.getParameter("userId");
        String tabId = request.getParameter("tabId");
        String url = request.getParameter("url");
        String dashboardName = request.getParameter("dashboardName");
        String group = request.getParameter("group");

        out.print(userPrefsServiceClient.addGadgetToUser(userId, tabId, url, dashboardName, group));

    } else if ("addNewTab".equals(funcName)) {
        String userId = request.getParameter("userId");
        String tabTitle = request.getParameter("tabTitle");
        String dashboardName = request.getParameter("dashboardName");

        out.print(userPrefsServiceClient.addNewTab(userId, tabTitle, dashboardName));

    } else if ("getGadgetLayout".equals(funcName)) {
        String userId = request.getParameter("userId");
        String tabId = request.getParameter("tabId");
        String dashboardName = request.getParameter("dashboardName");

        out.print(userPrefsServiceClient.getGadgetLayout(userId, tabId, dashboardName));

    } else if ("getGadgetPrefs".equals(funcName)) {
        String userId = request.getParameter("userId");
        String gadgetId = request.getParameter("gadgetId");
        String prefId = request.getParameter("prefId");
        String dashboardName = request.getParameter("dashboardName");

        out.print(userPrefsServiceClient.getGadgetPrefs(userId, gadgetId, prefId, dashboardName));

    } else if ("getGadgetUrlsToLayout".equals(funcName)) {
        String userId = request.getParameter("userId");
        String tabId = request.getParameter("tabId");
        String dashboardName = request.getParameter("dashboardName");

        String[] urlsToLayout =
                userPrefsServiceClient.getGadgetUrlsToLayout(userId, tabId, dashboardName, backendServerURL);
        String jsArray = "";
        if (urlsToLayout != null) {
            for (int x = 0; x < urlsToLayout.length; x++) {
                if (x == 0) {
                    jsArray = jsArray + urlsToLayout[x];
                } else {
                    jsArray = jsArray + "," + urlsToLayout[x];
                }
            }
        }

        out.print(jsArray);

    } else if ("getTabLayout".equals(funcName)) {
        String userId = request.getParameter("userId");
        String dashboardName = request.getParameter("dashboardName");

        out.print(userPrefsServiceClient.getTabLayout(userId, dashboardName));

    } else if ("getTabTitle".equals(funcName)) {
        String userId = request.getParameter("userId");
        String tabId = request.getParameter("tabId");
        String dashboardName = request.getParameter("dashboardName");

        out.print(userPrefsServiceClient.getTabTitle(userId, tabId, dashboardName));

    } else if ("isReadOnlyMode".equals(funcName)) {
        String userId = request.getParameter("userId");

        out.print(userPrefsServiceClient.isReadOnlyMode(userId));

    } else if ("removeGadget".equals(funcName)) {
        String userId = request.getParameter("userId");
        String tabId = request.getParameter("tabId");
        String dashboardName = request.getParameter("dashboardName");
        String gadgetId = request.getParameter("gadgetId");

        out.print(userPrefsServiceClient.removeGadget(userId, tabId, gadgetId, dashboardName));

    } else if ("removeTab".equals(funcName)) {
        String userId = request.getParameter("userId");
        String tabId = request.getParameter("tabId");
        String dashboardName = request.getParameter("dashboardName");

        out.print(userPrefsServiceClient.removeTab(userId, tabId, dashboardName));

    } else if ("setGadgetLayout".equals(funcName)) {
        String userId = request.getParameter("userId");
        String tabId = request.getParameter("tabId");
        String dashboardName = request.getParameter("dashboardName");
        String newLayout = request.getParameter("newLayout");

        out.print(userPrefsServiceClient.setGadgetLayout(userId, tabId, newLayout, dashboardName));

    } else if ("setGadgetPrefs".equals(funcName)) {
        String userId = request.getParameter("userId");
        String gadgetId = request.getParameter("gadgetId");
        String prefId = request.getParameter("prefId");
        String value = request.getParameter("value");
        String dashboardName = request.getParameter("dashboardName");

        out.print(userPrefsServiceClient.setGadgetPrefs(userId, gadgetId, prefId, value,
                dashboardName));

    } else if ("duplicateTab".equals(funcName)) {
        String userId = request.getParameter("userId");
        String dashboardName = request.getParameter("dashboardName");
        String sourceTabId = request.getParameter("sourceTabId");
        String newTabName = request.getParameter("newTabName");

        out.print(userPrefsServiceClient.duplicateTab(userId, dashboardName, sourceTabId, newTabName));
    } else if ("copyGadget".equals(funcName)) {
        String userId = request.getParameter("userId");
        String tabId = request.getParameter("tab");
        String dashboardName = request.getParameter("dashboardName");
        String sourceGadgetId = request.getParameter("sourceGadgetId");

        out.print(userPrefsServiceClient.copyGadget(userId, tabId, dashboardName, sourceGadgetId, "G1#"));
    } else if ("moveGadget".equals(funcName)) {
        String userId = request.getParameter("userId");
        String tabId = request.getParameter("tab");
        String dashboardName = request.getParameter("dashboardName");
        String sourceGadgetId = request.getParameter("sourceGadgetId");

        out.print(userPrefsServiceClient.moveGadgetToTab(userId, dashboardName, sourceGadgetId, tabId));
    }
%>